echo on;
%DEMO_KASKADE3b - Anwendung von Kaskade.m auf dreischleifige Kaskadenregelstruktur.
%Berechnet werden fhrungsoptimale Regler fr 4 Varianten:
%                             bod/bod/bod; eez/eez/eez; eez/bod/bod; eez/eez/bod; 
% >>>UNTERSCHIED zu DEMO_KASKADE1: Stroptimierung fr mittlere Schleife<<<
% >>>UNTERSCHIED zu DEMO_KASKADE3: alle Beispiele mit 3 Schleifen<<<
%Keine Begrenzung: praktische Bercksichtigung durch Begrenzungsrckrechnung (BRR)
T=1;    %Abtastzeit
SZ=300; %Simulationszeit=Anzahl von Abtastperioden T

% A: >>>Vorgaben fr inneren Regelkreis (z.B: Stromregelung)<<<
%Kopplung und Messung: Halteglied / Augenblickswertmessung
IWS1=1;
%Strecke: Verstrkung / Zwei Verzgerungsglieder 1. Ordnung
SP1=tf(50,conv([1.5 1],[5 1]),'Variable','p'),
%Regler: BOD-PI / unverzgerte Einganssignale / Polkompensation
s='bod'; SV=[0 1 0 1 0 0]; TV=[T,0,IWS1];
SM1=struct('Optimierung',s,'OhneMenue',SV,'RegelKreis',TV);
pause %Bitte bettigen Sie eine beliebige Taste

% B: >>>Vorgaben fr mittleren Regelkreis (z.B: Drehzahlregelung)<<<
%Kopplung und Messung: Halteglied / Augenblickswertmessung
IWS2=1;
%Strecke: Verstrkung / Ein Verzgerungsglied 1. Ordnung (Reibung!)
SP2=tf(2/0.01,[20/0.01 1],'Variable','p'),
%Regler: BOD-PI / verzgerte Einganssignale / keine Polkompensation
s='bod'; SV=[1 0 0 0 1 0]; TV=[T,0,IWS2];
SM2=struct('Optimierung',s,'OhneMenue',SV,'RegelKreis',TV);
pause %Bitte bettigen Sie eine beliebige Taste

% C: >>>Vorgaben fr ueren Regelkreis (z.B: Positionierung)<<<
%Kopplung und Messung: Halteglied / Augenblickswertmessung
IWS3=1;
%Strecke: Ein Integrator
SP3=tf(1,[100 0],'Variable','p'),
%Regler: BOD-P / unverzgerte Einganssignale
s='bod'; SV=[0 0 1 0 0 0]; TV=[T,0,IWS3];
SM3=struct('Optimierung',s,'OhneMenue',SV,'RegelKreis',TV);
pause %Bitte bettigen Sie eine beliebige Taste

%Berechnung der Vorfilter und Regler:
[FI11,RE11,FI21,RE21,FI31,RE31]=kaskade(SM1,SP1,SM2,SP2,SM3,SP3);
FI1=FI11;RE1=RE11;FI2=FI21;RE2=RE21;FI3=FI31;RE3=RE31;
SWA=1; %Sollwertsprung
SGA=5; SSZ=150; %Strgrennderung, Zeitpunkt
DEMO_KASKADEs; sim('DEMO_KASKADEs',T*SZ);
pause %Bitte bettigen Sie eine beliebige Taste

%2. Beispiel
%A - Regler: EEZ / unverzgerte Einganssignale / Minimalform
s='eez'; SV=[0 -1 -1 0 0 0]; TV=[T,0,IWS1];
SM1=struct('Optimierung',s,'OhneMenue',SV,'RegelKreis',TV);
%B - Regler: EEZ / verzgerte Einganssignale / Minimalform
s='eez'; SV=[1 1 0 0 0 0]; TV=[T,0,IWS2];
SM2=struct('Optimierung',s,'OhneMenue',SV,'RegelKreis',TV);
%C - Regler: EEZ / unverzgerte Einganssignale / Minimalform
s='eez'; SV=[0 0 0 0 0 0 0 1 0 0 1]; TV=[T,0,IWS3];
SM3=struct('Optimierung',s,'OhneMenue',SV,'RegelKreis',TV);
%Berechnung der Vorfilter und Regler: nur zum Vergleich
%i.a. EEZ-Stroptimierung nur fr innere EEZ-Schleifen zulssig
[FI13,RE13,FI23,RE23,FI33,RE33]=kaskade(SM1,SP1,SM2,SP2,SM3,SP3);
FI1=FI13;RE1=RE13;FI2=FI23;RE2=RE23;FI3=FI33;RE3=RE33;
SWA=1;          %Sollwertsprung
SGA=50; SSZ=30; %Strgrennderung, Zeitpunkt
SZ=80;
DEMO_KASKADEs; sim('DEMO_KASKADEs',T*SZ);
pause %Bitte bettigen Sie eine beliebige Taste

%3. Beispiel
%A - Regler: EEZ / unverzgerte Einganssignale / Minimalform
s='eez'; SV=[0 -1 -1 0 0 0]; TV=[T,0,IWS1];
SM1=struct('Optimierung',s,'OhneMenue',SV,'RegelKreis',TV);
%B - Regler: BOD-PI / verzgerte Einganssignale / keine Polkompensation
s='bod'; SV=[1 0 0 0 1 0]; TV=[T,0,IWS2];
SM2=struct('Optimierung',s,'OhneMenue',SV,'RegelKreis',TV);
%C - Regler: BOD-P / unverzgerte Einganssignale
s='bod'; SV=[0 0 1 0 0 0]; TV=[T,0,IWS3];
SM3=struct('Optimierung',s,'OhneMenue',SV,'RegelKreis',TV);
%Berechnung der Vorfilter und Regler:
[FI14,RE14,FI24,RE24,FI34,RE34]=kaskade(SM1,SP1,SM2,SP2,SM3,SP3);
FI1=FI14;RE1=RE14;FI2=FI24;RE2=RE24;FI3=FI34;RE3=RE34;
SWA=1; %Sollwertsprung
SGA=20; SSZ=70; %Strgrennderung, Zeitpunkt
SZ=140;
DEMO_KASKADEs; sim('DEMO_KASKADEs',T*SZ);
pause %Bitte bettigen Sie eine beliebige Taste

%4. Beispiel
%A - Regler: EEZ / unverzgerte Einganssignale / Minimalform
s='eez'; SV=[0 -1 -1 0 0 0]; TV=[T,0,IWS1];
SM1=struct('Optimierung',s,'OhneMenue',SV,'RegelKreis',TV);
%B - Regler: EEZ / verzgerte Einganssignale / Minimalform
s='eez'; SV=[1 1 0 0 0 0]; TV=[T,0,IWS2];
SM2=struct('Optimierung',s,'OhneMenue',SV,'RegelKreis',TV);
%C - Regler: BOD-P / unverzgerte Einganssignale
s='bod'; SV=[0 0 1 0 0 0]; TV=[T,0,IWS3];
SM3=struct('Optimierung',s,'OhneMenue',SV,'RegelKreis',TV);
%Berechnung der Vorfilter und Regler:
[FI12,RE12,FI22,RE22,FI32,RE32]=kaskade(SM1,SP1,SM2,SP2,SM3,SP3);
FI1=FI12;RE1=RE12;FI2=FI22;RE2=RE22;;FI3=FI32;RE3=RE32;
SWA=1;         %Sollwertsprung
SGA=20; SSZ=30; %Strgrennderung, Zeitpunkt
SZ=80;
DEMO_KASKADEs; sim('DEMO_KASKADEs',T*SZ);
echo off;
clear FI1   FI13  FI21  FI24  FI33  IWS2  RE11  RE14  RE22  RE3   RE34  SM2   SP2
clear FI11  FI14  FI22  FI3   FI34  IWS3  RE12  RE2   RE23  RE31  SGA   SM3   SP3
clear FI12  FI2   FI23  FI31  IWS1  RE1   RE13  RE21  RE24  RE33  SM1   SP1   SSZ 
clear SV    T     tout  SWA   TV    SZ    s
